package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.ItemAdicional;
import com.rjconsultores.ventaboletos.service.ItemAdicionalService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

@Controller("editarItemAdicionalController")
@Scope("prototype")
public class EditarItemAdicionalController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(EditarItemAdicionalController.class);

	@Autowired
	private ItemAdicionalService itemAdicionalService;

	private ItemAdicional itemAdicional;
	private MyListbox itemAdicionalList;
	private MyTextbox txtDescItemAdicional;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		itemAdicional = (ItemAdicional) Executions.getCurrent().getArg().get("itemAdicional");
		itemAdicionalList = (MyListbox) Executions.getCurrent().getArg().get("itemAdicionalList");

		if (itemAdicional.getItemadicionalId() != null) {
			txtDescItemAdicional.setValue(itemAdicional.getDescitemadicional());
		}
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {

		try {
			itemAdicional.setDescitemadicional(txtDescItemAdicional.getValue());

			if (itemAdicional.getItemadicionalId() == null) {
				itemAdicionalService.suscribir(itemAdicional);
				itemAdicionalList.addItemNovo(itemAdicional);
			} else {
				itemAdicionalService.actualizacion(itemAdicional);
			}

			closeWindow();

		} catch (WrongValueException ex) {
			throw (WrongValueException) ex;
		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(Labels.getLabel("MSG.Error").concat(" - ").concat(ex.toString()),
					Labels.getLabel("editarConfiguracionPacoteController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}
}
